#include<stdio.h>
#include<stdlib.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<string.h>
#include<arpa/inet.h>
#include<unistd.h>

int main(void) {
    /* CREATE SOCKET */
    int sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if(sock == -1) {
        perror("SOCKET COULD NOT BE OPENED");
        exit(EXIT_FAILURE);
    }

    /* BIND SOCKET */
    struct sockaddr_in sin;
    memset(&sin, 0, sizeof(struct sockaddr_in));
    sin.sin_family = AF_INET;
    sin.sin_port = htons(54321);
    sin.sin_addr.s_addr = htonl(INADDR_ANY);

    /* CONNECT TO SERVER */
    socklen_t address_len = sizeof(struct sockaddr_in);
    if(
        connect(sock, (struct sockaddr*)&sin, address_len) == -1
    ) {
        perror("COULD NOT CONNECT TO SERVER");
        exit(EXIT_FAILURE);
    }
    printf("CONNECTED TO SERVER\n");

    /* SEND msg1 */
    char const* msg1 = "Hello!\n";
    size_t msgLen = strlen(msg1);
    if(
        send(sock, msg1, msgLen, 0) == -1
    ) {
        perror("FAILED TO SEND msg1");
        exit(EXIT_FAILURE);
    }

    /* RECEIVE msg2 */
    size_t const BUFFSIZE = 256;
    char recvBuff[BUFFSIZE];
    if(
        recv(sock, recvBuff, BUFFSIZE, 0) == -1
    ) {
        perror("FAILED TO RECEIVE msg2");
        exit(EXIT_FAILURE);
    }
    printf("%s", recvBuff);
    sleep(2);

    /* SEND msg3 */
    char const* msg3 = "I've been trying to reach you about your car's extended warranty.\n";
    msgLen = strlen(msg3);
    if(
        send(sock, msg3, msgLen, 0) == -1
    ) {
        perror("FAILED TO SEND msg3");
        exit(EXIT_FAILURE);
    }

    /* RECEIVE msg4 */
    if(
            recv(sock, recvBuff, BUFFSIZE, 0) == -1
        ) {
            perror("FAILED TO RECEIVE msg4");
            exit(EXIT_FAILURE);
        }
    printf("%s", recvBuff);
    sleep(2);
    close(sock);
}
