#include<stdio.h>
#include<stdlib.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<string.h>
#include<arpa/inet.h>
#include<unistd.h>

int main(void) {
    /* CREATE SOCKET */
    int sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if(sock == -1) {
        perror("SOCKET COULD NOT BE OPENED");
        exit(EXIT_FAILURE);
    }

    /* CREATE ADDRESS */
    struct sockaddr_in sin;
    memset(&sin, 0, sizeof(struct sockaddr_in));
    sin.sin_family = AF_INET;
    sin.sin_port = htons(54321);
    sin.sin_addr.s_addr = htonl(INADDR_ANY);

    /* BIND SOCKET */
    int bind_ret = bind(sock, (struct sockaddr*)&sin,
                        sizeof(struct sockaddr_in));
    if(bind_ret == -1){
        perror("TCP BIND");
        exit(EXIT_FAILURE);
    }

    /* LISTEN FOR REQUESTS */
    if( 
        listen(sock, 1) == -1
    ) {
        perror("TCP LISTEN");
        exit(EXIT_FAILURE);
    }
    /* ACCEPT CONNECTION */
    socklen_t address_len = sizeof(struct sockaddr_in);
    int client_sock;
    if(
        (client_sock = accept(sock, (struct sockaddr*)&sin, &address_len)) == -1
    ) {
        perror("COULD NOT CONNECT TO CLIENT");
        exit(EXIT_FAILURE);
    }
    printf("CONNECTED TO CLIENT\n");

    /* RECEIVE msg1 */
    size_t const BUFFSIZE = 256;
    char recvBuff[BUFFSIZE];
    if(
            recv(client_sock, recvBuff, BUFFSIZE, 0) == -1
        ) {
            perror("FAILED TO RECEIVE msg1");
            exit(EXIT_FAILURE);
        }
    printf("%s", recvBuff);
    sleep(2);

    /* SEND msg2 */
    char const* msg2 = "Hi there!\n";
    size_t msgLen = strlen(msg2);
    if(
        send(client_sock, msg2, msgLen, 0) == -1
    ) {
        perror("FAILED TO SEND msg2");
        exit(EXIT_FAILURE);
    }

    /* RECEIVE msg3 */
    if(
            recv(client_sock, recvBuff, BUFFSIZE, 0) == -1
        ) {
            perror("FAILED TO RECEIVE msg3");
            exit(EXIT_FAILURE);
        }
    printf("%s", recvBuff);
    sleep(2);

    /* SEND msg4 */
    char const* msg4 = "No thanks.\n";
    msgLen = strlen(msg4);
    if(
        send(client_sock, msg4, msgLen, 0) == -1
    ) {
        perror("FAILED TO SEND msg4");
        exit(EXIT_FAILURE);
    }
    close(sock);
}